#include "VSensorLaser.h" 
#include <signal.h> 
#include <direct.h> 
#pragma comment(lib, "VSensorLaserSDK.lib")
using namespace std;
using namespace VSENSORLASER;
int main()
{
    //获取相对路径
    char cwd[200];
    if (_getcwd(cwd, 200) == nullptr)
    {
        printf("get path failed\n");
    }
    //实例化设备
    VSensorLaser* pVSensor = new VSensorLaser();
    //获取设备列表
    VSensorLaserCameraInfo cameraList[20];
    int num = 0;
    pVSensor->GetDeviceList(cameraList, &num);
    for (int i = 0; i < num; i++)
    {
        printf("device num %d : list[%d] = %s\n", i, i, cameraList[i].CameraName);
    }
    //连接设备，0为连接第一台设备  
    int status = pVSensor->DeviceConnect(0);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("connect device failed status = %d\n", status);
        system("pause");
    }
    //设置投影等级
    status = pVSensor->SetProjectLight(1);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set project light failed, status = %d\n", status);
        system("pause");
    }
    //设置手动HDR
    status = pVSensor->SetHDR(1.0, 5.0, true);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set hand HDR failed, status = %d\n", status);
        system("pause");
    }
    //设置为采集模式
    status = pVSensor->SetCaptureMode(emVSensorLaserCaptureMode::MODE_SOFT);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set capture mode failed, status = %d\n", status);
        system("pause");
    }
    //单次采集
    printf("start single capture...\n");
    VSensorLaserResult* pResult = new VSensorLaserResult;
    status = pVSensor->SingleRestruction(pResult, emVSensorLaserCaptureOutputMode::OUTPUT_MODE_ALL);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("single restruction failed, status = %d\n", status);
        system("pause");
    }
    //保存无序点云为pcd格式
    status = pVSensor->Save3DCloud(string(cwd) + "//test.pcd", pResult, emVSensorLaserPointType::POINT_TYPR_DISORDER);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("save 3D points failed, status = %d\n", status);
        system("pause");
    }
    //反初始化设备
    status = pVSensor->DeviceUnInit();
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("device release failed, status = %d\n", status);
        system("pause");
    }
    delete pResult;
    delete pVSensor;
    printf("run success\n");
    system("pause");
    return 0;
}